# coding: utf-8

"""
    Harbor API

    These APIs provide services for manipulating Harbor project.  # noqa: E501

    OpenAPI spec version: 2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from harbor_client.configuration import Configuration


class OIDCUserInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'int',
        'user_id': 'int',
        'subiss': 'str',
        'secret': 'str',
        'creation_time': 'datetime',
        'update_time': 'datetime'
    }

    attribute_map = {
        'id': 'id',
        'user_id': 'user_id',
        'subiss': 'subiss',
        'secret': 'secret',
        'creation_time': 'creation_time',
        'update_time': 'update_time'
    }

    def __init__(self, id=None, user_id=None, subiss=None, secret=None, creation_time=None, update_time=None, _configuration=None):  # noqa: E501
        """OIDCUserInfo - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._id = None
        self._user_id = None
        self._subiss = None
        self._secret = None
        self._creation_time = None
        self._update_time = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if user_id is not None:
            self.user_id = user_id
        if subiss is not None:
            self.subiss = subiss
        if secret is not None:
            self.secret = secret
        if creation_time is not None:
            self.creation_time = creation_time
        if update_time is not None:
            self.update_time = update_time

    @property
    def id(self):
        """Gets the id of this OIDCUserInfo.  # noqa: E501

        the ID of the OIDC info record  # noqa: E501

        :return: The id of this OIDCUserInfo.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this OIDCUserInfo.

        the ID of the OIDC info record  # noqa: E501

        :param id: The id of this OIDCUserInfo.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def user_id(self):
        """Gets the user_id of this OIDCUserInfo.  # noqa: E501

        the ID of the user  # noqa: E501

        :return: The user_id of this OIDCUserInfo.  # noqa: E501
        :rtype: int
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id):
        """Sets the user_id of this OIDCUserInfo.

        the ID of the user  # noqa: E501

        :param user_id: The user_id of this OIDCUserInfo.  # noqa: E501
        :type: int
        """

        self._user_id = user_id

    @property
    def subiss(self):
        """Gets the subiss of this OIDCUserInfo.  # noqa: E501

        the concatenation of sub and issuer in the ID token  # noqa: E501

        :return: The subiss of this OIDCUserInfo.  # noqa: E501
        :rtype: str
        """
        return self._subiss

    @subiss.setter
    def subiss(self, subiss):
        """Sets the subiss of this OIDCUserInfo.

        the concatenation of sub and issuer in the ID token  # noqa: E501

        :param subiss: The subiss of this OIDCUserInfo.  # noqa: E501
        :type: str
        """

        self._subiss = subiss

    @property
    def secret(self):
        """Gets the secret of this OIDCUserInfo.  # noqa: E501

        the secret of the OIDC user that can be used for CLI to push/pull artifacts  # noqa: E501

        :return: The secret of this OIDCUserInfo.  # noqa: E501
        :rtype: str
        """
        return self._secret

    @secret.setter
    def secret(self, secret):
        """Sets the secret of this OIDCUserInfo.

        the secret of the OIDC user that can be used for CLI to push/pull artifacts  # noqa: E501

        :param secret: The secret of this OIDCUserInfo.  # noqa: E501
        :type: str
        """

        self._secret = secret

    @property
    def creation_time(self):
        """Gets the creation_time of this OIDCUserInfo.  # noqa: E501

        The creation time of the OIDC user info record.  # noqa: E501

        :return: The creation_time of this OIDCUserInfo.  # noqa: E501
        :rtype: datetime
        """
        return self._creation_time

    @creation_time.setter
    def creation_time(self, creation_time):
        """Sets the creation_time of this OIDCUserInfo.

        The creation time of the OIDC user info record.  # noqa: E501

        :param creation_time: The creation_time of this OIDCUserInfo.  # noqa: E501
        :type: datetime
        """

        self._creation_time = creation_time

    @property
    def update_time(self):
        """Gets the update_time of this OIDCUserInfo.  # noqa: E501

        The update time of the OIDC user info record.  # noqa: E501

        :return: The update_time of this OIDCUserInfo.  # noqa: E501
        :rtype: datetime
        """
        return self._update_time

    @update_time.setter
    def update_time(self, update_time):
        """Sets the update_time of this OIDCUserInfo.

        The update time of the OIDC user info record.  # noqa: E501

        :param update_time: The update_time of this OIDCUserInfo.  # noqa: E501
        :type: datetime
        """

        self._update_time = update_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OIDCUserInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OIDCUserInfo):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OIDCUserInfo):
            return True

        return self.to_dict() != other.to_dict()
